unit Unit1;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
 StdCtrls;

type

 { TForm1 }

 TForm1 = class(TForm)
  Button1: TButton;
  Button2: TButton;
  Button3: TButton;
  ComboBox1: TComboBox;
  ComboBox2: TComboBox;
  ComboBox3: TComboBox;
  ComboBox4: TComboBox;
  Edit1: TEdit;
  Edit2: TEdit;
  Edit3: TEdit;
  Edit4: TEdit;
  Edit5: TEdit;
  Edit6: TEdit;
  Edit7: TEdit;
  Edit8: TEdit;
  Label1: TLabel;
  Label10: TLabel;
  Label11: TLabel;
  Label2: TLabel;
  Label3: TLabel;
  Label4: TLabel;
  Label5: TLabel;
  Label6: TLabel;
  Label7: TLabel;
  Label8: TLabel;
  Label9: TLabel;
  Memo1: TMemo;
  Memo2: TMemo;
  Memo3: TMemo;
  PageControl1: TPageControl;
  PageControl2: TPageControl;
  PageControl3: TPageControl;
  TabSheet1: TTabSheet;
  TabSheet2: TTabSheet;
  TabSheet3: TTabSheet;
  TabSheet4: TTabSheet;
  TabSheet5: TTabSheet;
  procedure Button1Click(Sender: TObject);
  procedure Button2Click(Sender: TObject);
  procedure Button3Click(Sender: TObject);
  procedure FormCreate(Sender: TObject);
 private
  { private declarations }
 public
  { public declarations }
 end;

var
 Form1: TForm1;

function newfloattostr(wert:double): String;
function newstrtofloat(s:string):double;

implementation

{$R *.lfm}

// Neue FloatToSTR-Funktion
// setzt die Dezimaltrenner auf ',' und später
// auf den Orginalwert zurück.
function newfloattostr(wert:double): String;
var
  old_DecSep: Char;
begin
  old_DecSep:=FormatSettings.DecimalSeparator;
  FormatSettings.DecimalSeparator:= ',';
  newfloattostr :=FloatToStr(wert);
  FormatSettings.DecimalSeparator := old_DecSep;
end;

// Neue StrToFloat-Funktion
// setzt die Dezimaltrenner auf ',' und später
// auf den Orginalwert zurück.
function newstrtofloat(s:string): double;
var
  old_DecSep: Char;
begin
  (* alle '.' durch ',' ersetzen *)
  while pos('.',s) > 0 do s[pos('.',s)] :=',';
  old_DecSep:=FormatSettings.DecimalSeparator;
  FormatSettings.DecimalSeparator:= ',';
  newstrtofloat := Strtofloat(s);
  FormatSettings.DecimalSeparator := old_DecSep;
end;

{ TForm1 }

// Minmal ReZahl aus Profildicke berechnen
procedure TForm1.Button1Click(Sender: TObject);
var Profildicke:double;
    MinRe:integer;
begin
 try
  Profildicke:=newstrtofloat(edit1.text);
 except
  showmessage('Fehlerhafte Eingabe ! , bitte nur Zahlenwerte eintragen ');
  edit1.SetFocus;
 end;
 MinRe:=round(Profildicke*10000);
 edit2.text:=inttostr(minRe);
end;

// Profildicke aus Flächenbelastung berechnen
procedure TForm1.Button2Click(Sender: TObject);
var flaeche,masse,Profildicke:double;
begin
 // Flächeninhalt lesen
 try
  flaeche:=newstrtofloat(edit3.text);
 except
  showmessage('Fehlerhafte Eingabe ! , bitte nur Zahlenwerte eintragen ');
  edit3.SetFocus;
  exit;
 end;
 // Modellmasse lesen
 try
  masse:=newstrtofloat(edit4.text);
 except
  showmessage('Fehlerhafte Eingabe ! , bitte nur Zahlenwerte eintragen ');
  edit4.SetFocus;
  exit;
 end;

 // Umrechnen der Eingaben (je nach gewählter Einheit) auf dm^2 und gramm
 // Fläche
 case combobox1.ItemIndex of
  // mm^2 nach dm^2
  0:
    flaeche:=flaeche/10000;
  // m^2 nach dm^2
  2:
    flaeche:=flaeche*100;
 end;
 // Masse
 case combobox2.ItemIndex of
  // kg nach gramm
  1:
    masse:=masse*1000;
 end;

 // Formel
 Profildicke:=1.75*sqrt(masse/flaeche);
 edit5.text:=Format('%5.2f',[Profildicke]);
end;

// Re-Zahl berechnen
procedure TForm1.Button3Click(Sender: TObject);
var Profiltiefe,Geschwindigkeit,Re_Zahl:double;
begin
 // Profiltiefe lesen
 try
  Profiltiefe:=newstrtofloat(edit6.text);
 except
  showmessage('Fehlerhafte Eingabe ! , bitte nur Zahlenwerte eintragen ');
  edit6.SetFocus;
  exit;
 end;
 // Geschwindigkeit lesen
 try
  Geschwindigkeit:=newstrtofloat(edit7.text);
 except
  showmessage('Fehlerhafte Eingabe ! , bitte nur Zahlenwerte eintragen ');
  edit7.SetFocus;
  exit;
 end;

 // Umrechnen der Eingaben (je nach gewählter Einheit) auf m und m/s
 // Profiltiefe
 case combobox4.ItemIndex of
  // mm nach m
  0:
    Profiltiefe:=Profiltiefe/1000;
 end;
 // Geschwindigkeit
 case combobox3.ItemIndex of
  // km/h nach m/s
  1:
    Geschwindigkeit:=Geschwindigkeit/3.6;
 end;

 // Formel
 Re_Zahl:=Profiltiefe*Geschwindigkeit*69930;
 edit8.text:=Format('%8.0f',[Re_Zahl]);
end;

// Grundeinstellungen
procedure TForm1.FormCreate(Sender: TObject);
begin
 pagecontrol1.PageIndex:=0;
 pagecontrol2.PageIndex:=0;
end;

end.

